/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * git-shell-test
 * Copyright (C) James Liggett 2010 <jrliggett@cox.net>
 * 
 * git-shell-test is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * git-shell-test is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GIT_STASH_CHANGES_PANE_H_
#define _GIT_STASH_CHANGES_PANE_H_

#include <glib-object.h>
#include <libanjuta/anjuta-column-text-view.h>
#include "git-pane.h"
#include "git-stash-pane.h"
#include "git-stash-save-command.h"

G_BEGIN_DECLS

#define GIT_TYPE_STASH_CHANGES_PANE             (git_stash_changes_pane_get_type ())
#define GIT_STASH_CHANGES_PANE(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), GIT_TYPE_STASH_CHANGES_PANE, GitStashChangesPane))
#define GIT_STASH_CHANGES_PANE_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), GIT_TYPE_STASH_CHANGES_PANE, GitStashChangesPaneClass))
#define GIT_IS_STASH_CHANGES_PANE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GIT_TYPE_STASH_CHANGES_PANE))
#define GIT_IS_STASH_CHANGES_PANE_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), GIT_TYPE_STASH_CHANGES_PANE))
#define GIT_STASH_CHANGES_PANE_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), GIT_TYPE_STASH_CHANGES_PANE, GitStashChangesPaneClass))

typedef struct _GitStashChangesPaneClass GitStashChangesPaneClass;
typedef struct _GitStashChangesPane GitStashChangesPane;
typedef struct _GitStashChangesPanePriv GitStashChangesPanePriv;

struct _GitStashChangesPaneClass
{
	GitPaneClass parent_class;
};

struct _GitStashChangesPane
{
	GitPane parent_instance;

	GitStashChangesPanePriv *priv;
};

GType git_stash_changes_pane_get_type (void) G_GNUC_CONST;
AnjutaDockPane *git_stash_changes_pane_new (Git *plugin);
void on_stash_changes_button_clicked (GtkAction *action, 
                                      Git *plugin);

G_END_DECLS

#endif /* _GIT_STASH_CHANGES_PANE_H_ */
