/* locator.c generated by valac 0.39.92, the Vala compiler
 * generated from locator.vala, do not modify */

/*
 * Copyright (C) 2008 Abderrahim Kitouni
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Finds the innermost block containing the given location */


#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <string.h>


#define TYPE_BLOCK_LOCATOR (block_locator_get_type ())
#define BLOCK_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLOCK_LOCATOR, BlockLocator))
#define BLOCK_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLOCK_LOCATOR, BlockLocatorClass))
#define IS_BLOCK_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLOCK_LOCATOR))
#define IS_BLOCK_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLOCK_LOCATOR))
#define BLOCK_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLOCK_LOCATOR, BlockLocatorClass))

typedef struct _BlockLocator BlockLocator;
typedef struct _BlockLocatorClass BlockLocatorClass;
typedef struct _BlockLocatorPrivate BlockLocatorPrivate;

#define BLOCK_LOCATOR_TYPE_LOCATION (block_locator_location_get_type ())
typedef struct _BlockLocatorLocation BlockLocatorLocation;
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

struct _BlockLocator {
	ValaCodeVisitor parent_instance;
	BlockLocatorPrivate * priv;
};

struct _BlockLocatorClass {
	ValaCodeVisitorClass parent_class;
};

struct _BlockLocatorLocation {
	gint line;
	gint column;
};

struct _BlockLocatorPrivate {
	BlockLocatorLocation location;
	ValaSymbol* innermost;
	BlockLocatorLocation innermost_begin;
	BlockLocatorLocation innermost_end;
};


static gpointer block_locator_parent_class = NULL;
static GType block_locator_type_id = 0;

GType block_locator_get_type (void) G_GNUC_CONST;
static GType block_locator_location_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static BlockLocatorLocation* block_locator_location_dup (const BlockLocatorLocation* self);
static void block_locator_location_free (BlockLocatorLocation* self);
#define BLOCK_LOCATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BLOCK_LOCATOR, BlockLocatorPrivate))
ValaSymbol* block_locator_locate (BlockLocator* self,
                                  ValaSourceFile* file,
                                  gint line,
                                  gint column);
static void block_locator_location_init (BlockLocatorLocation *self,
                                  gint line,
                                  gint column);
static gboolean block_locator_update_location (BlockLocator* self,
                                        ValaSymbol* s);
static gboolean block_locator_location_inside (BlockLocatorLocation *self,
                                        ValaSourceReference* src);
static gboolean block_locator_location_before (BlockLocatorLocation *self,
                                        BlockLocatorLocation* other);
static void block_locator_real_visit_block (ValaCodeVisitor* base,
                                     ValaBlock* b);
static void block_locator_real_visit_namespace (ValaCodeVisitor* base,
                                         ValaNamespace* ns);
static void block_locator_real_visit_class (ValaCodeVisitor* base,
                                     ValaClass* cl);
static void block_locator_real_visit_struct (ValaCodeVisitor* base,
                                      ValaStruct* st);
static void block_locator_real_visit_interface (ValaCodeVisitor* base,
                                         ValaInterface* iface);
static void block_locator_real_visit_method (ValaCodeVisitor* base,
                                      ValaMethod* m);
static void block_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                               ValaCreationMethod* m);
static void block_locator_real_visit_property (ValaCodeVisitor* base,
                                        ValaProperty* prop);
static void block_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                                 ValaPropertyAccessor* acc);
static void block_locator_real_visit_constructor (ValaCodeVisitor* base,
                                           ValaConstructor* c);
static void block_locator_real_visit_destructor (ValaCodeVisitor* base,
                                          ValaDestructor* d);
static void block_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                            ValaIfStatement* stmt);
static void block_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                                ValaSwitchStatement* stmt);
static void block_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                              ValaSwitchSection* section);
static void block_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                               ValaWhileStatement* stmt);
static void block_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                            ValaDoStatement* stmt);
static void block_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                             ValaForStatement* stmt);
static void block_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                 ValaForeachStatement* stmt);
static void block_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                             ValaTryStatement* stmt);
static void block_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                            ValaCatchClause* clause);
static void block_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                              ValaLockStatement* stmt);
static void block_locator_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                 ValaLambdaExpression* expr);
static void block_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                                    ValaExpressionStatement* stmt);
static void block_locator_real_visit_method_call (ValaCodeVisitor* base,
                                           ValaMethodCall* mc);
static void block_locator_real_visit_signal (ValaCodeVisitor* base,
                                      ValaSignal* sig);
BlockLocator* block_locator_new (void);
BlockLocator* block_locator_construct (GType object_type);
static void block_locator_finalize (ValaCodeVisitor * obj);


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


ValaSymbol*
block_locator_locate (BlockLocator* self,
                      ValaSourceFile* file,
                      gint line,
                      gint column)
{
	ValaSymbol* result = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	block_locator_location_init (&self->priv->location, line, column);
	_vala_code_node_unref0 (self->priv->innermost);
	self->priv->innermost = NULL;
	vala_source_file_accept_children (file, (ValaCodeVisitor*) self);
	_tmp0_ = self->priv->innermost;
	_tmp1_ = _vala_code_node_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static gboolean
block_locator_update_location (BlockLocator* self,
                               ValaSymbol* s)
{
	gboolean result = FALSE;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	BlockLocatorLocation begin = {0};
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceLocation _tmp4_ = {0};
	ValaSourceLocation _tmp5_;
	gint _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaSourceReference* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	gint _tmp11_;
	BlockLocatorLocation end = {0};
	ValaSourceReference* _tmp12_;
	ValaSourceReference* _tmp13_;
	ValaSourceLocation _tmp14_ = {0};
	ValaSourceLocation _tmp15_;
	gint _tmp16_;
	ValaSourceReference* _tmp17_;
	ValaSourceReference* _tmp18_;
	ValaSourceLocation _tmp19_ = {0};
	ValaSourceLocation _tmp20_;
	gint _tmp21_;
	gboolean _tmp22_ = FALSE;
	ValaSymbol* _tmp23_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (s != NULL, FALSE);
	_tmp0_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp1_ = _tmp0_;
	if (!block_locator_location_inside (&self->priv->location, _tmp1_)) {
		result = FALSE;
		return result;
	}
	_tmp2_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp3_ = _tmp2_;
	vala_source_reference_get_begin (_tmp3_, &_tmp4_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_.line;
	_tmp7_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp8_ = _tmp7_;
	vala_source_reference_get_begin (_tmp8_, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_.column;
	block_locator_location_init (&begin, _tmp6_, _tmp11_);
	_tmp12_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp13_ = _tmp12_;
	vala_source_reference_get_end (_tmp13_, &_tmp14_);
	_tmp15_ = _tmp14_;
	_tmp16_ = _tmp15_.line;
	_tmp17_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp18_ = _tmp17_;
	vala_source_reference_get_end (_tmp18_, &_tmp19_);
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_.column;
	block_locator_location_init (&end, _tmp16_, _tmp21_);
	_tmp23_ = self->priv->innermost;
	if (_tmp23_ == NULL) {
		_tmp22_ = TRUE;
	} else {
		gboolean _tmp24_ = FALSE;
		BlockLocatorLocation _tmp25_;
		_tmp25_ = begin;
		if (block_locator_location_before (&self->priv->innermost_begin, &_tmp25_)) {
			BlockLocatorLocation _tmp26_;
			_tmp26_ = self->priv->innermost_end;
			_tmp24_ = block_locator_location_before (&end, &_tmp26_);
		} else {
			_tmp24_ = FALSE;
		}
		_tmp22_ = _tmp24_;
	}
	if (_tmp22_) {
		ValaSymbol* _tmp27_;
		BlockLocatorLocation _tmp28_;
		BlockLocatorLocation _tmp29_;
		_tmp27_ = _vala_code_node_ref0 (s);
		_vala_code_node_unref0 (self->priv->innermost);
		self->priv->innermost = _tmp27_;
		_tmp28_ = begin;
		self->priv->innermost_begin = _tmp28_;
		_tmp29_ = end;
		self->priv->innermost_end = _tmp29_;
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static void
block_locator_real_visit_block (ValaCodeVisitor* base,
                                ValaBlock* b)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (b != NULL);
	if (block_locator_update_location (self, (ValaSymbol*) b)) {
		vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
	}
}


static void
block_locator_real_visit_namespace (ValaCodeVisitor* base,
                                    ValaNamespace* ns)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (ns != NULL);
	block_locator_update_location (self, (ValaSymbol*) ns);
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_class (ValaCodeVisitor* base,
                                ValaClass* cl)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (cl != NULL);
	if (block_locator_update_location (self, (ValaSymbol*) cl)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_struct (ValaCodeVisitor* base,
                                 ValaStruct* st)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (st != NULL);
	if (block_locator_update_location (self, (ValaSymbol*) st)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_interface (ValaCodeVisitor* base,
                                    ValaInterface* iface)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (iface != NULL);
	if (block_locator_update_location (self, (ValaSymbol*) iface)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_method (ValaCodeVisitor* base,
                                 ValaMethod* m)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (m != NULL);
	if (block_locator_update_location (self, (ValaSymbol*) m)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                          ValaCreationMethod* m)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (m != NULL);
	if (block_locator_update_location (self, (ValaSymbol*) m)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_property (ValaCodeVisitor* base,
                                   ValaProperty* prop)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (prop != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                            ValaPropertyAccessor* acc)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (acc != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_constructor (ValaCodeVisitor* base,
                                      ValaConstructor* c)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (c != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_destructor (ValaCodeVisitor* base,
                                     ValaDestructor* d)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (d != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                       ValaIfStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                           ValaSwitchStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                         ValaSwitchSection* section)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (section != NULL);
	vala_code_visitor_visit_block ((ValaCodeVisitor*) self, (ValaBlock*) section);
}


static void
block_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                          ValaWhileStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                       ValaDoStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                        ValaForStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                            ValaForeachStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                        ValaTryStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                       ValaCatchClause* clause)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (clause != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                         ValaLockStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_lambda_expression (ValaCodeVisitor* base,
                                            ValaLambdaExpression* expr)
{
	BlockLocator * self;
	ValaBlock* _tmp0_;
	ValaBlock* _tmp1_;
	self = (BlockLocator*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = vala_lambda_expression_get_statement_body (expr);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ValaBlock* _tmp2_;
		ValaBlock* _tmp3_;
		_tmp2_ = vala_lambda_expression_get_statement_body (expr);
		_tmp3_ = _tmp2_;
		if (block_locator_update_location (self, (ValaSymbol*) _tmp3_)) {
			ValaBlock* _tmp4_;
			ValaBlock* _tmp5_;
			_tmp4_ = vala_lambda_expression_get_statement_body (expr);
			_tmp5_ = _tmp4_;
			vala_code_node_accept_children ((ValaCodeNode*) _tmp5_, (ValaCodeVisitor*) self);
		}
	} else {
		vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
	}
}


static void
block_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                               ValaExpressionStatement* stmt)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_method_call (ValaCodeVisitor* base,
                                      ValaMethodCall* mc)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (mc != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) mc, (ValaCodeVisitor*) self);
}


static void
block_locator_real_visit_signal (ValaCodeVisitor* base,
                                 ValaSignal* sig)
{
	BlockLocator * self;
	self = (BlockLocator*) base;
	g_return_if_fail (sig != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) sig, (ValaCodeVisitor*) self);
}


BlockLocator*
block_locator_construct (GType object_type)
{
	BlockLocator* self = NULL;
	self = (BlockLocator*) vala_code_visitor_construct (object_type);
	return self;
}


BlockLocator*
block_locator_new (void)
{
	return block_locator_construct (TYPE_BLOCK_LOCATOR);
}


static void
block_locator_location_init (BlockLocatorLocation *self,
                             gint line,
                             gint column)
{
	memset (self, 0, sizeof (BlockLocatorLocation));
	(*self).line = line;
	(*self).column = column;
}


static gboolean
block_locator_location_inside (BlockLocatorLocation *self,
                               ValaSourceReference* src)
{
	gboolean result = FALSE;
	BlockLocatorLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	gint _tmp2_;
	ValaSourceLocation _tmp3_ = {0};
	ValaSourceLocation _tmp4_;
	gint _tmp5_;
	BlockLocatorLocation end = {0};
	ValaSourceLocation _tmp6_ = {0};
	ValaSourceLocation _tmp7_;
	gint _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_ = FALSE;
	g_return_val_if_fail (src != NULL, FALSE);
	vala_source_reference_get_begin (src, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_.line;
	vala_source_reference_get_begin (src, &_tmp3_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_.column;
	block_locator_location_init (&begin, _tmp2_, _tmp5_);
	vala_source_reference_get_end (src, &_tmp6_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _tmp7_.line;
	vala_source_reference_get_end (src, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_.column;
	block_locator_location_init (&end, _tmp8_, _tmp11_);
	if (block_locator_location_before (&begin, &(*self))) {
		BlockLocatorLocation _tmp13_;
		_tmp13_ = end;
		_tmp12_ = block_locator_location_before (&(*self), &_tmp13_);
	} else {
		_tmp12_ = FALSE;
	}
	result = _tmp12_;
	return result;
}


static gboolean
block_locator_location_before (BlockLocatorLocation *self,
                               BlockLocatorLocation* other)
{
	gboolean result = FALSE;
	gint _tmp0_;
	BlockLocatorLocation _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	BlockLocatorLocation _tmp5_;
	gint _tmp6_;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = (*self).line;
	_tmp1_ = *other;
	_tmp2_ = _tmp1_.line;
	if (_tmp0_ > _tmp2_) {
		result = FALSE;
		return result;
	}
	_tmp4_ = (*self).line;
	_tmp5_ = *other;
	_tmp6_ = _tmp5_.line;
	if (_tmp4_ == _tmp6_) {
		gint _tmp7_;
		BlockLocatorLocation _tmp8_;
		gint _tmp9_;
		_tmp7_ = (*self).column;
		_tmp8_ = *other;
		_tmp9_ = _tmp8_.column;
		_tmp3_ = _tmp7_ > _tmp9_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


static BlockLocatorLocation*
block_locator_location_dup (const BlockLocatorLocation* self)
{
	BlockLocatorLocation* dup;
	dup = g_new0 (BlockLocatorLocation, 1);
	memcpy (dup, self, sizeof (BlockLocatorLocation));
	return dup;
}


static void
block_locator_location_free (BlockLocatorLocation* self)
{
	g_free (self);
}


static GType
block_locator_location_get_type (void)
{
	static volatile gsize block_locator_location_type_id__volatile = 0;
	if (g_once_init_enter (&block_locator_location_type_id__volatile)) {
		GType block_locator_location_type_id;
		block_locator_location_type_id = g_boxed_type_register_static ("BlockLocatorLocation", (GBoxedCopyFunc) block_locator_location_dup, (GBoxedFreeFunc) block_locator_location_free);
		g_once_init_leave (&block_locator_location_type_id__volatile, block_locator_location_type_id);
	}
	return block_locator_location_type_id__volatile;
}


static void
block_locator_class_init (BlockLocatorClass * klass)
{
	block_locator_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = block_locator_finalize;
	g_type_class_add_private (klass, sizeof (BlockLocatorPrivate));
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor *, ValaBlock*)) block_locator_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor *, ValaNamespace*)) block_locator_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor *, ValaClass*)) block_locator_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor *, ValaStruct*)) block_locator_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor *, ValaInterface*)) block_locator_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor *, ValaMethod*)) block_locator_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor *, ValaCreationMethod*)) block_locator_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor *, ValaProperty*)) block_locator_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor *, ValaPropertyAccessor*)) block_locator_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor *, ValaConstructor*)) block_locator_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor *, ValaDestructor*)) block_locator_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor *, ValaIfStatement*)) block_locator_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor *, ValaSwitchStatement*)) block_locator_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor *, ValaSwitchSection*)) block_locator_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor *, ValaWhileStatement*)) block_locator_real_visit_while_statement;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor *, ValaDoStatement*)) block_locator_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor *, ValaForStatement*)) block_locator_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor *, ValaForeachStatement*)) block_locator_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor *, ValaTryStatement*)) block_locator_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor *, ValaCatchClause*)) block_locator_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor *, ValaLockStatement*)) block_locator_real_visit_lock_statement;
	((ValaCodeVisitorClass *) klass)->visit_lambda_expression = (void (*) (ValaCodeVisitor *, ValaLambdaExpression*)) block_locator_real_visit_lambda_expression;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor *, ValaExpressionStatement*)) block_locator_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor *, ValaMethodCall*)) block_locator_real_visit_method_call;
	((ValaCodeVisitorClass *) klass)->visit_signal = (void (*) (ValaCodeVisitor *, ValaSignal*)) block_locator_real_visit_signal;
}


static void
block_locator_instance_init (BlockLocator * self)
{
	self->priv = BLOCK_LOCATOR_GET_PRIVATE (self);
}


static void
block_locator_finalize (ValaCodeVisitor * obj)
{
	BlockLocator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLOCK_LOCATOR, BlockLocator);
	_vala_code_node_unref0 (self->priv->innermost);
	VALA_CODE_VISITOR_CLASS (block_locator_parent_class)->finalize (obj);
}


GType
block_locator_get_type (void)
{
	return block_locator_type_id;
}


GType
block_locator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BlockLocatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) block_locator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BlockLocator), 0, (GInstanceInitFunc) block_locator_instance_init, NULL };
	block_locator_type_id = g_type_module_register_type (module, VALA_TYPE_CODE_VISITOR, "BlockLocator", &g_define_type_info, 0);
	return block_locator_type_id;
}



