/* report.c generated by valac 0.39.92, the Vala compiler
 * generated from report.vala, do not modify */

/*
 * Copyright (C) 2008-2009 Abderrahim Kitouni
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* A Vala.Report subclass for reporting errors in Anjuta UI */


#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <libanjuta/interfaces/libanjuta-interfaces.h>
#include <valagee.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define TYPE_ANJUTA_REPORT (anjuta_report_get_type ())
#define ANJUTA_REPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANJUTA_REPORT, AnjutaReport))
#define ANJUTA_REPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANJUTA_REPORT, AnjutaReportClass))
#define IS_ANJUTA_REPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANJUTA_REPORT))
#define IS_ANJUTA_REPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANJUTA_REPORT))
#define ANJUTA_REPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANJUTA_REPORT, AnjutaReportClass))

typedef struct _AnjutaReport AnjutaReport;
typedef struct _AnjutaReportClass AnjutaReportClass;
typedef struct _AnjutaReportPrivate AnjutaReportPrivate;

#define ANJUTA_REPORT_TYPE_ERROR (anjuta_report_error_get_type ())
typedef struct _AnjutaReportError AnjutaReportError;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _anjuta_report_error_free0(var) ((var == NULL) ? NULL : (var = (anjuta_report_error_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _AnjutaReport {
	ValaReport parent_instance;
	AnjutaReportPrivate * priv;
};

struct _AnjutaReportClass {
	ValaReportClass parent_class;
};

struct _AnjutaReportError {
	ValaSourceReference* source;
	gboolean error;
	gchar* message;
};

struct _AnjutaReportPrivate {
	IAnjutaDocumentManager* _docman;
	ValaList* errors_list;
	GRecMutex __lock_errors_list;
	gboolean general_error;
};


static gpointer anjuta_report_parent_class = NULL;
static GType anjuta_report_type_id = 0;

GType anjuta_report_get_type (void) G_GNUC_CONST;
static GType anjuta_report_error_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static AnjutaReportError* anjuta_report_error_dup (const AnjutaReportError* self);
static void anjuta_report_error_free (AnjutaReportError* self);
static void anjuta_report_error_copy (const AnjutaReportError* self,
                               AnjutaReportError* dest);
static void anjuta_report_error_destroy (AnjutaReportError* self);
#define ANJUTA_REPORT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ANJUTA_REPORT, AnjutaReportPrivate))
void anjuta_report_update_errors (AnjutaReport* self,
                                  IAnjutaEditor* editor);
void anjuta_report_clear_error_indicators (AnjutaReport* self,
                                           ValaSourceFile* file);
IAnjutaDocumentManager* anjuta_report_get_docman (AnjutaReport* self);
static void anjuta_report_real_warn (ValaReport* base,
                              ValaSourceReference* source,
                              const gchar* message);
static void anjuta_report_real_err (ValaReport* base,
                             ValaSourceReference* source,
                             const gchar* message);
AnjutaReport* anjuta_report_new (void);
AnjutaReport* anjuta_report_construct (GType object_type);
void anjuta_report_set_docman (AnjutaReport* self,
                               IAnjutaDocumentManager* value);
static void anjuta_report_finalize (ValaReport * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}


void
anjuta_report_update_errors (AnjutaReport* self,
                             IAnjutaEditor* editor)
{
	IAnjutaIndicable* ind = NULL;
	IAnjutaIndicable* _tmp0_;
	IAnjutaMarkable* mark = NULL;
	IAnjutaMarkable* _tmp1_;
	gboolean _tmp2_ = FALSE;
	IAnjutaIndicable* _tmp3_;
	IAnjutaIndicable* _tmp5_;
	IAnjutaMarkable* _tmp7_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (editor != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (editor, ianjuta_indicable_get_type ()) ? ((IAnjutaIndicable*) editor) : NULL);
	ind = _tmp0_;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (editor, ianjuta_markable_get_type ()) ? ((IAnjutaMarkable*) editor) : NULL);
	mark = _tmp1_;
	_tmp3_ = ind;
	if (_tmp3_ == NULL) {
		IAnjutaMarkable* _tmp4_;
		_tmp4_ = mark;
		_tmp2_ = _tmp4_ == NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_g_object_unref0 (mark);
		_g_object_unref0 (ind);
		return;
	}
	_tmp5_ = ind;
	if (_tmp5_ != NULL) {
		IAnjutaIndicable* _tmp6_;
		_tmp6_ = ind;
		ianjuta_indicable_clear (_tmp6_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (mark);
			_g_object_unref0 (ind);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp7_ = mark;
	if (_tmp7_ != NULL) {
		IAnjutaMarkable* _tmp8_;
		_tmp8_ = mark;
		ianjuta_markable_delete_all_markers (_tmp8_, IANJUTA_MARKABLE_MESSAGE, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (mark);
			_g_object_unref0 (ind);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		ValaList* _e_list = NULL;
		ValaList* _tmp9_;
		ValaList* _tmp10_;
		gint _e_size = 0;
		ValaList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _e_index = 0;
		_tmp9_ = self->priv->errors_list;
		_tmp10_ = _vala_iterable_ref0 (_tmp9_);
		_e_list = _tmp10_;
		_tmp11_ = _e_list;
		_tmp12_ = vala_collection_get_size ((ValaCollection*) _tmp11_);
		_tmp13_ = _tmp12_;
		_e_size = _tmp13_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			AnjutaReportError* e = NULL;
			ValaList* _tmp17_;
			gint _tmp18_;
			gpointer _tmp19_;
			const gchar* _tmp20_ = NULL;
			const gchar* _tmp21_;
			AnjutaReportError* _tmp22_;
			ValaSourceReference* _tmp23_;
			ValaSourceFile* _tmp24_;
			ValaSourceFile* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			_tmp14_ = _e_index;
			_e_index = _tmp14_ + 1;
			_tmp15_ = _e_index;
			_tmp16_ = _e_size;
			if (!(_tmp15_ < _tmp16_)) {
				break;
			}
			_tmp17_ = _e_list;
			_tmp18_ = _e_index;
			_tmp19_ = vala_list_get (_tmp17_, _tmp18_);
			e = (AnjutaReportError*) _tmp19_;
			_tmp21_ = ianjuta_document_get_filename (G_TYPE_CHECK_INSTANCE_CAST (editor, ianjuta_document_get_type (), IAnjutaDocument), &_inner_error_);
			_tmp20_ = _tmp21_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_anjuta_report_error_free0 (e);
				_vala_iterable_unref0 (_e_list);
				_g_object_unref0 (mark);
				_g_object_unref0 (ind);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp22_ = e;
			_tmp23_ = (*_tmp22_).source;
			_tmp24_ = vala_source_reference_get_file (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = vala_source_file_get_filename (_tmp25_);
			_tmp27_ = _tmp26_;
			if (g_str_has_suffix (_tmp27_, _tmp20_)) {
				IAnjutaIndicable* _tmp28_;
				_tmp28_ = ind;
				if (_tmp28_ != NULL) {
					IAnjutaIterable* begin_iter = NULL;
					AnjutaReportError* _tmp29_;
					ValaSourceReference* _tmp30_;
					ValaSourceLocation _tmp31_ = {0};
					ValaSourceLocation _tmp32_;
					gint _tmp33_;
					IAnjutaIterable* _tmp34_;
					IAnjutaIterable* end_iter = NULL;
					AnjutaReportError* _tmp44_;
					ValaSourceReference* _tmp45_;
					ValaSourceLocation _tmp46_ = {0};
					ValaSourceLocation _tmp47_;
					gint _tmp48_;
					IAnjutaIterable* _tmp49_;
					IAnjutaIndicableIndicator _tmp59_ = 0;
					AnjutaReportError* _tmp60_;
					gboolean _tmp61_;
					IAnjutaIndicable* _tmp62_;
					IAnjutaIterable* _tmp63_;
					IAnjutaIterable* _tmp64_;
					_tmp29_ = e;
					_tmp30_ = (*_tmp29_).source;
					vala_source_reference_get_begin (_tmp30_, &_tmp31_);
					_tmp32_ = _tmp31_;
					_tmp33_ = _tmp32_.line;
					_tmp34_ = ianjuta_editor_get_line_begin_position (editor, _tmp33_, &_inner_error_);
					begin_iter = _tmp34_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					{
						gint i = 0;
						i = 1;
						{
							gboolean _tmp35_ = FALSE;
							_tmp35_ = TRUE;
							while (TRUE) {
								gint _tmp37_;
								AnjutaReportError* _tmp38_;
								ValaSourceReference* _tmp39_;
								ValaSourceLocation _tmp40_ = {0};
								ValaSourceLocation _tmp41_;
								gint _tmp42_;
								IAnjutaIterable* _tmp43_;
								if (!_tmp35_) {
									gint _tmp36_;
									_tmp36_ = i;
									i = _tmp36_ + 1;
								}
								_tmp35_ = FALSE;
								_tmp37_ = i;
								_tmp38_ = e;
								_tmp39_ = (*_tmp38_).source;
								vala_source_reference_get_begin (_tmp39_, &_tmp40_);
								_tmp41_ = _tmp40_;
								_tmp42_ = _tmp41_.column;
								if (!(_tmp37_ < _tmp42_)) {
									break;
								}
								_tmp43_ = begin_iter;
								ianjuta_iterable_next (_tmp43_, &_inner_error_);
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									_g_object_unref0 (begin_iter);
									_anjuta_report_error_free0 (e);
									_vala_iterable_unref0 (_e_list);
									_g_object_unref0 (mark);
									_g_object_unref0 (ind);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return;
								}
							}
						}
					}
					_tmp44_ = e;
					_tmp45_ = (*_tmp44_).source;
					vala_source_reference_get_end (_tmp45_, &_tmp46_);
					_tmp47_ = _tmp46_;
					_tmp48_ = _tmp47_.line;
					_tmp49_ = ianjuta_editor_get_line_begin_position (editor, _tmp48_, &_inner_error_);
					end_iter = _tmp49_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_object_unref0 (begin_iter);
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp50_ = FALSE;
							_tmp50_ = TRUE;
							while (TRUE) {
								gint _tmp52_;
								AnjutaReportError* _tmp53_;
								ValaSourceReference* _tmp54_;
								ValaSourceLocation _tmp55_ = {0};
								ValaSourceLocation _tmp56_;
								gint _tmp57_;
								IAnjutaIterable* _tmp58_;
								if (!_tmp50_) {
									gint _tmp51_;
									_tmp51_ = i;
									i = _tmp51_ + 1;
								}
								_tmp50_ = FALSE;
								_tmp52_ = i;
								_tmp53_ = e;
								_tmp54_ = (*_tmp53_).source;
								vala_source_reference_get_end (_tmp54_, &_tmp55_);
								_tmp56_ = _tmp55_;
								_tmp57_ = _tmp56_.column;
								if (!(_tmp52_ < _tmp57_)) {
									break;
								}
								_tmp58_ = end_iter;
								ianjuta_iterable_next (_tmp58_, &_inner_error_);
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									_g_object_unref0 (end_iter);
									_g_object_unref0 (begin_iter);
									_anjuta_report_error_free0 (e);
									_vala_iterable_unref0 (_e_list);
									_g_object_unref0 (mark);
									_g_object_unref0 (ind);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return;
								}
							}
						}
					}
					_tmp60_ = e;
					_tmp61_ = (*_tmp60_).error;
					if (_tmp61_) {
						_tmp59_ = IANJUTA_INDICABLE_CRITICAL;
					} else {
						_tmp59_ = IANJUTA_INDICABLE_WARNING;
					}
					_tmp62_ = ind;
					_tmp63_ = begin_iter;
					_tmp64_ = end_iter;
					ianjuta_indicable_set (_tmp62_, _tmp63_, _tmp64_, _tmp59_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_object_unref0 (end_iter);
						_g_object_unref0 (begin_iter);
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					_g_object_unref0 (end_iter);
					_g_object_unref0 (begin_iter);
				}
				if (G_TYPE_CHECK_INSTANCE_TYPE (editor, ianjuta_markable_get_type ())) {
					IAnjutaMarkable* _tmp65_;
					AnjutaReportError* _tmp66_;
					ValaSourceReference* _tmp67_;
					ValaSourceLocation _tmp68_ = {0};
					ValaSourceLocation _tmp69_;
					gint _tmp70_;
					AnjutaReportError* _tmp71_;
					const gchar* _tmp72_;
					_tmp65_ = mark;
					_tmp66_ = e;
					_tmp67_ = (*_tmp66_).source;
					vala_source_reference_get_begin (_tmp67_, &_tmp68_);
					_tmp69_ = _tmp68_;
					_tmp70_ = _tmp69_.line;
					_tmp71_ = e;
					_tmp72_ = (*_tmp71_).message;
					ianjuta_markable_mark (_tmp65_, _tmp70_, IANJUTA_MARKABLE_MESSAGE, _tmp72_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
			}
			_anjuta_report_error_free0 (e);
		}
		_vala_iterable_unref0 (_e_list);
	}
	_g_object_unref0 (mark);
	_g_object_unref0 (ind);
}


void
anjuta_report_clear_error_indicators (AnjutaReport* self,
                                      ValaSourceFile* file)
{
	GList* _tmp34_ = NULL;
	IAnjutaDocumentManager* _tmp35_;
	GList* _tmp36_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	if (file == NULL) {
		GEqualFunc _tmp0_;
		ValaArrayList* _tmp1_;
		_tmp0_ = g_direct_equal;
		_tmp1_ = vala_array_list_new (ANJUTA_REPORT_TYPE_ERROR, (GBoxedCopyFunc) anjuta_report_error_dup, (GDestroyNotify) anjuta_report_error_free, _tmp0_);
		_vala_iterable_unref0 (self->priv->errors_list);
		self->priv->errors_list = (ValaList*) _tmp1_;
		((ValaReport*) self)->errors = 0;
	} else {
		ValaList* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp2_ = FALSE;
				_tmp2_ = TRUE;
				while (TRUE) {
					gint _tmp4_;
					ValaList* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
					ValaList* _tmp8_;
					gint _tmp9_;
					gpointer _tmp10_;
					AnjutaReportError* _tmp11_;
					ValaSourceReference* _tmp12_;
					ValaSourceFile* _tmp13_;
					ValaSourceFile* _tmp14_;
					gboolean _tmp15_;
					if (!_tmp2_) {
						gint _tmp3_;
						_tmp3_ = i;
						i = _tmp3_ + 1;
					}
					_tmp2_ = FALSE;
					_tmp4_ = i;
					_tmp5_ = self->priv->errors_list;
					_tmp6_ = vala_collection_get_size ((ValaCollection*) _tmp5_);
					_tmp7_ = _tmp6_;
					if (!(_tmp4_ < _tmp7_)) {
						break;
					}
					_tmp8_ = self->priv->errors_list;
					_tmp9_ = i;
					_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
					_tmp11_ = (AnjutaReportError*) _tmp10_;
					_tmp12_ = (*_tmp11_).source;
					_tmp13_ = vala_source_reference_get_file (_tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = _tmp14_ == file;
					_anjuta_report_error_free0 (_tmp11_);
					if (_tmp15_) {
						ValaList* _tmp16_;
						gint _tmp17_;
						gpointer _tmp18_;
						AnjutaReportError* _tmp19_;
						gboolean _tmp20_;
						gboolean _tmp21_;
						ValaList* _tmp24_;
						gint _tmp25_;
						gpointer _tmp26_;
						AnjutaReportError* _tmp27_;
						gint _tmp28_;
						_tmp16_ = self->priv->errors_list;
						_tmp17_ = i;
						_tmp18_ = vala_list_get (_tmp16_, _tmp17_);
						_tmp19_ = (AnjutaReportError*) _tmp18_;
						_tmp20_ = (*_tmp19_).error;
						_tmp21_ = _tmp20_;
						_anjuta_report_error_free0 (_tmp19_);
						if (_tmp21_) {
							gint _tmp22_;
							_tmp22_ = ((ValaReport*) self)->errors;
							((ValaReport*) self)->errors = _tmp22_ - 1;
						} else {
							gint _tmp23_;
							_tmp23_ = ((ValaReport*) self)->warnings;
							((ValaReport*) self)->warnings = _tmp23_ - 1;
						}
						_tmp24_ = self->priv->errors_list;
						_tmp25_ = i;
						_tmp26_ = vala_list_remove_at (_tmp24_, _tmp25_);
						_tmp27_ = (AnjutaReportError*) _tmp26_;
						_anjuta_report_error_free0 (_tmp27_);
						_tmp28_ = i;
						i = _tmp28_ - 1;
					}
				}
			}
		}
		_tmp29_ = self->priv->errors_list;
		_tmp30_ = vala_collection_get_size ((ValaCollection*) _tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = ((ValaReport*) self)->errors;
		_tmp33_ = ((ValaReport*) self)->warnings;
		_vala_assert (_tmp31_ <= (_tmp32_ + _tmp33_), "errors_list.size <= errors + warnings");
	}
	_tmp35_ = self->priv->_docman;
	_tmp36_ = ianjuta_document_manager_get_doc_widgets (_tmp35_, &_inner_error_);
	_tmp34_ = _tmp36_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GList* doc_collection = NULL;
		GList* doc_it = NULL;
		doc_collection = _tmp34_;
		for (doc_it = doc_collection; doc_it != NULL; doc_it = doc_it->next) {
			GtkWidget* doc = NULL;
			doc = (GtkWidget*) doc_it->data;
			{
				GtkWidget* _tmp37_;
				GtkWidget* _tmp39_;
				_tmp37_ = doc;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp37_, ianjuta_indicable_get_type ())) {
					GtkWidget* _tmp38_;
					_tmp38_ = doc;
					ianjuta_indicable_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, ianjuta_indicable_get_type (), IAnjutaIndicable), &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_list_free0 (_tmp34_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				_tmp39_ = doc;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp39_, ianjuta_markable_get_type ())) {
					GtkWidget* _tmp40_;
					_tmp40_ = doc;
					ianjuta_markable_delete_all_markers (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, ianjuta_markable_get_type (), IAnjutaMarkable), IANJUTA_MARKABLE_MESSAGE, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_list_free0 (_tmp34_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
			}
		}
	}
	_g_list_free0 (_tmp34_);
}


static gpointer
_vala_source_reference_ref0 (gpointer self)
{
	return self ? vala_source_reference_ref (self) : NULL;
}


static void
anjuta_report_real_warn (ValaReport* base,
                         ValaSourceReference* source,
                         const gchar* message)
{
	AnjutaReport * self;
	gint _tmp0_;
	GError * _inner_error_ = NULL;
	self = (AnjutaReport*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = ((ValaReport*) self)->warnings;
	((ValaReport*) self)->warnings = _tmp0_ + 1;
	if (source == NULL) {
		return;
	}
	{
		ValaList* _tmp1_;
		_tmp1_ = self->priv->errors_list;
		g_rec_mutex_lock (&self->priv->__lock_errors_list);
		{
			ValaList* _tmp2_;
			ValaSourceReference* _tmp3_;
			gchar* _tmp4_;
			AnjutaReportError _tmp5_ = {0};
			AnjutaReportError _tmp6_;
			AnjutaReportError _tmp7_;
			_tmp2_ = self->priv->errors_list;
			_tmp3_ = _vala_source_reference_ref0 (source);
			_tmp4_ = g_strdup (message);
			memset (&_tmp5_, 0, sizeof (AnjutaReportError));
			_vala_source_reference_unref0 (_tmp5_.source);
			_tmp5_.source = _tmp3_;
			_g_free0 (_tmp5_.message);
			_tmp5_.message = _tmp4_;
			_tmp5_.error = FALSE;
			_tmp6_ = _tmp5_;
			_tmp7_ = _tmp6_;
			vala_collection_add ((ValaCollection*) _tmp2_, &_tmp7_);
			anjuta_report_error_destroy (&_tmp6_);
		}
		__finally11:
		{
			ValaList* _tmp8_;
			_tmp8_ = self->priv->errors_list;
			g_rec_mutex_unlock (&self->priv->__lock_errors_list);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void
anjuta_report_real_err (ValaReport* base,
                        ValaSourceReference* source,
                        const gchar* message)
{
	AnjutaReport * self;
	gint _tmp0_;
	GError * _inner_error_ = NULL;
	self = (AnjutaReport*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = ((ValaReport*) self)->errors;
	((ValaReport*) self)->errors = _tmp0_ + 1;
	if (source == NULL) {
		self->priv->general_error = TRUE;
		return;
	}
	{
		ValaList* _tmp1_;
		_tmp1_ = self->priv->errors_list;
		g_rec_mutex_lock (&self->priv->__lock_errors_list);
		{
			ValaList* _tmp2_;
			ValaSourceReference* _tmp3_;
			gchar* _tmp4_;
			AnjutaReportError _tmp5_ = {0};
			AnjutaReportError _tmp6_;
			AnjutaReportError _tmp7_;
			_tmp2_ = self->priv->errors_list;
			_tmp3_ = _vala_source_reference_ref0 (source);
			_tmp4_ = g_strdup (message);
			memset (&_tmp5_, 0, sizeof (AnjutaReportError));
			_vala_source_reference_unref0 (_tmp5_.source);
			_tmp5_.source = _tmp3_;
			_g_free0 (_tmp5_.message);
			_tmp5_.message = _tmp4_;
			_tmp5_.error = TRUE;
			_tmp6_ = _tmp5_;
			_tmp7_ = _tmp6_;
			vala_collection_add ((ValaCollection*) _tmp2_, &_tmp7_);
			anjuta_report_error_destroy (&_tmp6_);
		}
		__finally12:
		{
			ValaList* _tmp8_;
			_tmp8_ = self->priv->errors_list;
			g_rec_mutex_unlock (&self->priv->__lock_errors_list);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


AnjutaReport*
anjuta_report_construct (GType object_type)
{
	AnjutaReport* self = NULL;
	self = (AnjutaReport*) vala_report_construct (object_type);
	return self;
}


AnjutaReport*
anjuta_report_new (void)
{
	return anjuta_report_construct (TYPE_ANJUTA_REPORT);
}


IAnjutaDocumentManager*
anjuta_report_get_docman (AnjutaReport* self)
{
	IAnjutaDocumentManager* result;
	IAnjutaDocumentManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_docman;
	result = _tmp0_;
	return result;
}


void
anjuta_report_set_docman (AnjutaReport* self,
                          IAnjutaDocumentManager* value)
{
	IAnjutaDocumentManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_docman);
	self->priv->_docman = _tmp0_;
}


static void
anjuta_report_error_copy (const AnjutaReportError* self,
                          AnjutaReportError* dest)
{
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = (*self).source;
	_tmp1_ = _vala_source_reference_ref0 (_tmp0_);
	_vala_source_reference_unref0 ((*dest).source);
	(*dest).source = _tmp1_;
	_tmp2_ = (*self).error;
	(*dest).error = _tmp2_;
	_tmp3_ = (*self).message;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 ((*dest).message);
	(*dest).message = _tmp4_;
}


static void
anjuta_report_error_destroy (AnjutaReportError* self)
{
	_vala_source_reference_unref0 ((*self).source);
	_g_free0 ((*self).message);
}


static AnjutaReportError*
anjuta_report_error_dup (const AnjutaReportError* self)
{
	AnjutaReportError* dup;
	dup = g_new0 (AnjutaReportError, 1);
	anjuta_report_error_copy (self, dup);
	return dup;
}


static void
anjuta_report_error_free (AnjutaReportError* self)
{
	anjuta_report_error_destroy (self);
	g_free (self);
}


static GType
anjuta_report_error_get_type (void)
{
	static volatile gsize anjuta_report_error_type_id__volatile = 0;
	if (g_once_init_enter (&anjuta_report_error_type_id__volatile)) {
		GType anjuta_report_error_type_id;
		anjuta_report_error_type_id = g_boxed_type_register_static ("AnjutaReportError", (GBoxedCopyFunc) anjuta_report_error_dup, (GBoxedFreeFunc) anjuta_report_error_free);
		g_once_init_leave (&anjuta_report_error_type_id__volatile, anjuta_report_error_type_id);
	}
	return anjuta_report_error_type_id__volatile;
}


static void
anjuta_report_class_init (AnjutaReportClass * klass)
{
	anjuta_report_parent_class = g_type_class_peek_parent (klass);
	((ValaReportClass *) klass)->finalize = anjuta_report_finalize;
	g_type_class_add_private (klass, sizeof (AnjutaReportPrivate));
	((ValaReportClass *) klass)->warn = (void (*) (ValaReport *, ValaSourceReference*, const gchar*)) anjuta_report_real_warn;
	((ValaReportClass *) klass)->err = (void (*) (ValaReport *, ValaSourceReference*, const gchar*)) anjuta_report_real_err;
}


static void
anjuta_report_instance_init (AnjutaReport * self)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = ANJUTA_REPORT_GET_PRIVATE (self);
	g_rec_mutex_init (&self->priv->__lock_errors_list);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (ANJUTA_REPORT_TYPE_ERROR, (GBoxedCopyFunc) anjuta_report_error_dup, (GDestroyNotify) anjuta_report_error_free, _tmp0_);
	self->priv->errors_list = (ValaList*) _tmp1_;
	self->priv->general_error = FALSE;
}


static void
anjuta_report_finalize (ValaReport * obj)
{
	AnjutaReport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANJUTA_REPORT, AnjutaReport);
	_g_object_unref0 (self->priv->_docman);
	g_rec_mutex_clear (&self->priv->__lock_errors_list);
	_vala_iterable_unref0 (self->priv->errors_list);
	VALA_REPORT_CLASS (anjuta_report_parent_class)->finalize (obj);
}


GType
anjuta_report_get_type (void)
{
	return anjuta_report_type_id;
}


GType
anjuta_report_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (AnjutaReportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) anjuta_report_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnjutaReport), 0, (GInstanceInitFunc) anjuta_report_instance_init, NULL };
	anjuta_report_type_id = g_type_module_register_type (module, VALA_TYPE_REPORT, "AnjutaReport", &g_define_type_info, 0);
	return anjuta_report_type_id;
}



